/***
 * OW2 FraSCAti explorer
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org
 *
 * Author: Christophe Demarey
 *
 * Contributor(s):
 * 
 */

package org.ow2.frascati.explorer.scaproperties;

import java.util.ArrayList;
import java.util.List;

import javax.swing.table.TableModel;

import org.ow2.frascati.tinfi.control.property.SCAPropertyController;

/**
 * A utility class providing static methods to build properties table model.
 * 
 * @author Christophe Demarey.
 */
public class PropertiesTableModelBuilder {

    public static TableModel buildAttributesTableModel(
            SCAPropertyController propertiesController) {
        List<PropertyDescriptor> properties = new ArrayList<PropertyDescriptor>();
        
        for (String prop : propertiesController.getAll().keySet() ) {
            Object value = propertiesController.get(prop);
            properties.add( new PropertyDescriptor(prop, value, true) );
        }
        
        return new PropertiesTableModel( properties.toArray(new PropertyDescriptor[0]) );
    }

}
