/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.binding;

import org.eclipse.stp.sca.BaseReference;
import org.eclipse.stp.sca.BaseService;
import org.eclipse.stp.sca.Binding;
import org.eclipse.stp.sca.ScaPackage;
import org.objectweb.fractal.api.Component;

/**
 * Bind components using Local Binding
 * 
 * @author <a href="mailto:damien.fournier@inria.fr">Damien Fournier</a>
 * @version $Revision$
 */

@org.objectweb.fractal.fraclet.annotations.Component
public class ScaBindingLocal implements ScaBindingProtocol {

  /**
   * The binding type according to the SCA model
   */

  public static int BINDING_TYPE = ScaPackage.SCA_BINDING;

  /**
   * Logger for this class
   */

  java.util.logging.Logger log = java.util.logging.Logger
      .getLogger(ScaBindingLocal.class.getCanonicalName());

  /*
   * (non-Javadoc)
   * 
   * @see org.ow2.frascati.factory.core.instance.binding.ScaBindingProtocol#bind(org.eclipse.stp.sca.BaseReference,
   *      org.eclipse.stp.sca.Binding, org.objectweb.fractal.api.Component)
   */

  public void bind(BaseReference reference, Binding binding, Component component) {
    log.finest("Nothing to do when using SCA binding");
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.ow2.frascati.factory.core.instance.binding.ScaBindingProtocol#export(org.eclipse.stp.sca.BaseService,
   *      org.eclipse.stp.sca.Binding, org.objectweb.fractal.api.Component)
   */

  public void export(BaseService service, Binding binding, Component component) {
    log.finest("Nothing to do when using SCA binding");
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.ow2.frascati.factory.core.instance.binding.ScaBindingProtocol#getBindingID()
   */

  public int getBindingID() {
    return BINDING_TYPE;
  }

}
