/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.intent;

import org.eclipse.emf.ecore.EObject;
import org.objectweb.fractal.fraclet.annotations.Interface;

/**
 * Set SCA Intents on component instances
 * 
 * @author <a href="mailto:damien.fournier@inria.fr">Damien Fournier</a>
 * @version $Revision$
 */

@Interface(name = "intent")
public interface ScaIntent {
  
  /**
   * Apply intent on the given Object
   *
   * @param o - Object on which the intent must be applied
   * @param modelElement - SCA Element using an intent
   */
  
  public void setIntent(Object o, EObject modelElement) throws IntentException;
  
  /**
   * @return ID of the SCA Element which has intent requirements
   */
  
  public int getEObjectID();

}
