/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.generate.implementation;

import org.eclipse.stp.sca.Implementation;
import org.eclipse.stp.sca.JavaImplementation;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.fraclet.annotations.Component;
import org.objectweb.fractal.fraclet.annotations.Requires;
import org.ow2.frascati.factory.core.instance.implementation.ScaImplementation;
import org.ow2.frascati.factory.core.instance.runtime.RuntimeFactory;

@Component
public class ScaJavaGenerateImpl implements ScaImplementation {

  /**
   * Logger for this class
   */

  java.util.logging.Logger log = java.util.logging.Logger
      .getLogger("assembly-factory");

  /**
   * The required runtime
   */

  @Requires(name = "runtime")
  RuntimeFactory runtime;

  public org.objectweb.fractal.api.Component create(Implementation implementation,
      ComponentType componentType) {
    
    JavaImplementation javaImp = (JavaImplementation) implementation;

    try {

      log.fine("Create java component for implementation "
          + javaImp.getClass_());
      
      // Test if java class is present in current classloader
      //Thread.currentThread().getContextClassLoader().loadClass(javaImp.getClass_());

      return runtime.newFcInstance(componentType, "scaPrimitive",
          javaImp.getClass_());

    } catch (InstantiationException e) {
      e.printStackTrace();
    } 
    return null;
  }

  /* (non-Javadoc)
   * @see org.ow2.frascati.factory.instance.implementation.ScaImplementation#getImplementationID()
   */
  
  public int getImplementationID() {
    return org.eclipse.stp.sca.ScaPackage.JAVA_IMPLEMENTATION;
  }

}
